//Cramer.c - Alain Brobecker, 2013/10/03

#include <stdio.h>  // file functions, etc...
#include <stdlib.h> // exit(), malloc()
#define NbMax 16
int perm_list[NbMax],perm_used[NbMax];
int NbPermutations,nb;

//Problme: dterminant=0
//A:=[[1,1,1,-1,-1,0,0,0],[1,1,1,0,0,-1,-1,-1],[0,1,1,-1,0,-1,0,0],[1,0,1,0,0,0,-1,0],[1,1,0,0,-1,0,0,-1],[1,1,0,0,0,-1,0,0],[0,1,1,0,0,0,0,-1],[1,1,1,1,1,1,1,1]];
//det(A);
//a+b+c=d+e+5
//a+b+c=f+g+h
//a+b+c=a+d+f
//a+b+c=b+g+5
//a+b+c=c+e+h
//a+b+c=c+f+5
//a+b+c=a+h+5
//a+b+c+d+e+f+g+h+5=45
//1;1;1;-1;-1;0;0;0;5
//1;1;1;0;0;-1;-1;-1;0
//0;1;1;-1;0;-1;0;0;0
//1;0;1;0;0;0;-1;0;5
//1;1;0;0;-1;0;0;-1;0
//1;1;0;0;0;-1;0;0;5
//0;1;1;0;0;0;0;-1;5
//1;1;1;1;1;1;1;1;40
//int A[8][8]={
//{1,1,1,-1,-1,0,0,0},
//{1,1,1,0,0,-1,-1,-1},
//{0,1,1,-1,0,-1,0,0},
//{1,0,1,0,0,0,-1,0},
//{1,1,0,0,-1,0,0,-1},
//{1,1,0,0,0,-1,0,0},
//{0,1,1,0,0,0,0,-1},
//{1,1,1,1,1,1,1,1}};
//int B[8]={5,0,0,5,0,5,5,40};


//A:=[[1,1,0,0,0],[0,1,1,0,0],[0,0,1,1,0],[0,0,0,1,1],[1,0,0,0,1]];
//det(A);
#define MatrixN 5
int A[MatrixN][MatrixN]={{1,1,0,0,0},{0,1,1,0,0},{0,0,1,1,0},{0,0,0,1,1},{1,0,0,0,1}};
int B[MatrixN]={6,0,4,8,2};

int Matrix[MatrixN][MatrixN];
int Determinant;


//**** DeterminantUnePermutation ****
void DeterminantUnePermutation(int depth) {
int c,d,e;
int signature,produit;
  for(c=0;c<nb;c++) {
    if(perm_used[c]==0) {
      perm_list[depth-1]=c;
      perm_used[c]=1;
      if(depth==nb) {
        //calcule la signature
        signature=1;
        for(d=0;d<nb-1;d++) {
          for(e=d+1;e<nb;e++) {
            if(perm_list[d]>perm_list[e]) { signature=-signature; }
          }
        }
        produit=1;
//!!!        printf("(");
        for(d=0;d<nb;d++) {
//!!!          printf("%d",perm_list[d]);
          produit=produit*Matrix[perm_list[d]][d];
        }
//!!!        printf(")\n");
//!!!        printf(" %d\n",signature);
        Determinant=Determinant+signature*produit;
        NbPermutations++;
      } else {
        DeterminantUnePermutation(depth+1);
      }
      perm_used[c]=0;
    }
  }
}

//**** READNUMBER ****
int ReadNumber(s) char *s; {
  int n,t,sign;
  unsigned char c;
  n=0;
  sign=1;
  t=0;
  c=s[t];
  if(c=='-') { sign=-1; t++; c=s[t]; }
  while(c!=0) {
    if((c<'0') || (c>'9')) {
      printf("Error: %s should be a number",s);
      exit(1);
    }
    n=n*10+c-'0';
    t++;
    c=s[t];
  }
  return(n*sign);
}

//**** MAIN ****
int main(argc,argv) int argc; char *argv[]; {
  int c,d,k,detA;
//  if(argc<=1) { printf("Usage: permute N\n"); exit(1); }
//  nb=ReadNumber(argv[1]);
  nb=MatrixN;

  //calcule det(A)
  for(c=0;c<MatrixN;c++) {
    for(d=0;d<MatrixN;d++) {
      Matrix[c][d]=A[c][d];
    }
  }
  for(c=0;c<nb;c++) { perm_used[c]=0; }
  NbPermutations=0;
  Determinant=0;
  DeterminantUnePermutation(1);
  detA=Determinant;
  printf("%d!=%d permutations of %d elements.\n",nb,NbPermutations,nb);
  printf("determinant(A)=%d\n",Determinant);

  if(detA!=0) {
    for(k=0;k<MatrixN;k++) {
      //copie la Matrice
      for(c=0;c<MatrixN;c++) {
        for(d=0;d<MatrixN;d++) {
          Matrix[c][d]=A[c][d];
        }
      }
      //copie B sur la kme colonne
      for(c=0;c<MatrixN;c++) {
        Matrix[k][c]=B[c];
      }
      for(c=0;c<nb;c++) { perm_used[c]=0; }
      NbPermutations=0;
      Determinant=0;
      DeterminantUnePermutation(1);
      printf("x_%d=%d/%d\n",k,Determinant,detA);
    }
  }
  exit(0);
}
