//Determinant.c - Alain Brobecker, 2013/10/03
//A:=[[1,2,3],[4,5,6],[0,8,9]];
//det(A); //21

#include <stdio.h>  // file functions, etc...
#include <stdlib.h> // exit(), malloc()
#define NbMax 16
int perm_list[NbMax],perm_used[NbMax];
int NbPermutations,nb;

int MatrixN=3;
int Matrix[3][3]={ {1,2,3},{4,5,6},{0,8,9}};
int Determinant=0;


//**** DeterminantUnePermutation ****
void DeterminantUnePermutation(int depth) {
int c,d,e;
int signature,produit;
  for(c=0;c<nb;c++) {
    if(perm_used[c]==0) {
      perm_list[depth-1]=c;
      perm_used[c]=1;
      if(depth==nb) {
        //calcule la signature
        signature=1;
        for(d=0;d<nb-1;d++) {
          for(e=d+1;e<nb;e++) {
            if(perm_list[d]>perm_list[e]) { signature=-signature; }
          }
        }
        produit=1;
//!!!        printf("(");
        for(d=0;d<nb;d++) { printf("%d",perm_list[d]); produit=produit*Matrix[perm_list[d]][d]; }
//!!!        printf(")\n");
        printf(" %d\n",signature);
        Determinant=Determinant+signature*produit;
        NbPermutations++;
      } else {
        DeterminantUnePermutation(depth+1);
      }
      perm_used[c]=0;
    }
  }
}

//**** READNUMBER ****
int ReadNumber(s) char *s; {
  int n,t,sign;
  unsigned char c;
  n=0;
  sign=1;
  t=0;
  c=s[t];
  if(c=='-') { sign=-1; t++; c=s[t]; }
  while(c!=0) {
    if((c<'0') || (c>'9')) {
      printf("Error: %s should be a number",s);
      exit(1);
    }
    n=n*10+c-'0';
    t++;
    c=s[t];
  }
  return(n*sign);
}

//**** MAIN ****
int main(argc,argv) int argc; char *argv[]; {
  int c;
//  if(argc<=1) { printf("Usage: permute N\n"); exit(1); }
//  nb=ReadNumber(argv[1]);
  nb=MatrixN;
  for(c=0;c<nb;c++) { perm_used[c]=0; }
  NbPermutations=0;
  DeterminantUnePermutation(1);
  printf("%d!=%d permutations of %d elements.\n",nb,NbPermutations,nb);
  printf("determinant=%d\n",Determinant);
  exit(0);
}
