// ExtractASCIIFromFile.c
// Alain Brobecker - 2016/09/14

#include <stdio.h>  /* file functions, etc... */
#include <stdlib.h> /* exit(), malloc() */

#define TRUE 1
#define FALSE 0


void AsciiExtract(adress,start,end) unsigned char *adress; int start,end; {
  int c,d,NbChars;
  NbChars=0;
  for(c=start;c<=end;c++) {
    if(NbChars==80) { printf("\n"); NbChars=0;}
    d=adress[c];
    if((d>=32) && (d<128)) { printf("%c",d); NbChars++; }
  }
}

/***************************************************************************/
int main(argc,argv) int argc; char *argv[]; {
  FILE *filep;
  int FileLength;
  unsigned char *File;

  if(argc!=2) { printf("usage: hexdump file\n"); exit(1); }

  // load file
  filep=fopen(argv[1],"rb");
  if(filep==0) { printf("error: %s not found\n",argv[1]); exit(1); }
  fseek(filep,0,2);
  FileLength=(int) ftell(filep);
  fseek(filep,0,0);
  File=(unsigned char *) malloc((unsigned int) FileLength);
  fread(File,1,FileLength,filep);
  fclose(filep);
  printf("%s: %d bytes\n",argv[1],FileLength);

  //dump it
  AsciiExtract(File,0,FileLength-1);

  exit(0);
}
