// IsPrime.c
#include <stdio.h>  // file functions, etc...
#include <stdlib.h> // exit(), malloc()
#define TRUE 1
#define FALSE 0

int IsPrime(int p) {
  int d;
  if(p<2) { return(FALSE); }
  if(p==2) { return(TRUE); }
  if((p%2)==0) { return(FALSE); }
  for(d=3;d<p;d=d+2) { if((p%d)==0) { return(FALSE); } }
  return(TRUE);
}

//**** READNUMBER ****
int ReadNumber(s) char *s; {
  int n,t,sign;
  unsigned char c;
  n=0;
  sign=1;
  t=0;
  c=s[t];
  if(c=='-') { sign=-1; t++; c=s[t]; }
  while(c!=0) {
    if((c<'0') || (c>'9')) {
      printf("Error: %s should be a number",s);
      exit(1);
    }
    n=n*10+c-'0';
    t++;
    c=s[t];
  }
  return(n*sign);
}

int main(argc,argv) int argc; char *argv[]; {
  setbuf(stdout, NULL); // no buffering for output!
  int c;

  //Read from command line
  if(argc<=1) { printf("Usage: IsPrime Number\n"); exit(1); }
  c=ReadNumber(argv[1]);
  if(IsPrime(c)==TRUE) { printf("%d is prime!\n",c); }
  exit(0);
}
