/* algebre.c - Alain Brobecker, 20080927 */
#include <stdio.h>  /* file functions, etc... */
#include <stdlib.h> /* exit(), malloc() */

#define nmax 20

//**** GCD ****
int gcd(p,q) int p,q; {
  int r;
  if((r=p%q)==0) {
    return q;
  } else {
    return(gcd(q,r));
  }
}

//**** LCM ****
int lcm(p,q) int p,q; { return(p*q/gcd(p,q)); }


//**** MAIN ****
int main(argc,argv) int argc; char *argv[]; {
  setbuf(stdout, NULL); /* no buffering for output! */

  int ordre[nmax+1];
  int n,e,a,b;

  /* on se place dans (Z/nZ,+) */
  for(n=2;n<nmax+1;n++) {
    printf("Dans (Z/%dZ,+)\n",n);
    /* calcule l'ordre de chaque lment */
    for(e=0;e<n;e++) {
      ordre[e]=1;
      while((e*ordre[e]%n)!=0) {
        ordre[e]++;
      }
      printf(" ordre[%d]=%d\n",e,ordre[e]);
    }
    /* pour tout (a;b) regarder si ordre[a+b]<lcm(ordre[a],ordre[b]) */
    a=0;
    while(a<n) {
      b=0;
      while((b<=a) && (a+b<n)) {
        if(ordre[a+b]<lcm(ordre[a],ordre[b])) {
          printf("  ordre[%d+%d]=%d < lcm(ordre[%d],ordre[%d])=lcm(%d,%d)=%d\n",a,b,ordre[a+b],a,b,ordre[a],ordre[b],lcm(ordre[a],ordre[b]));
        }
        b++;
      }
      a++;
    }



  }



  exit(0);
}
