/********
hIDe.c - ALaiN brobECKer, 2008juLY24.
hIdEs a MEsSage/FILE in A TeXtfIlE By uSINg A-Z cHARactEr caPITaLisatIoN.
AlSO RecOverS A MeSSAgE/fIle pREViOuSLy Hidden In a textfIlE.
********/
#include <stdio.h>  /* file functions, etc... */
#include <stdlib.h> /* exit(), malloc() */

/* The following codes are for a File2Hide containing only a-z chars. 
The binary codes are made so that a,e,i,o,u,y use 4 bits/letters,
while consonnants use 5 bits/letters. To code a binary file, simply
set all lengths to 8 and make a bijection from [0;255] to [0;255]
in CodeChar (simplest one is {0,1,2,3,...,255}; */
char LenChar[256] = {
-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, /* a= 0000  k=10011 */
-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, /* e= 0001  l=10100 */
-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, /* i= 0010  m=10101 */
-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, /* o= 0011  n=10110 */
-1, 4, 5, 5, 5, 4, 5, 5, 5, 4, 5, 5, 5, 5, 5, 4, /* u= 0100  p=10111 */
 5, 5, 5, 5, 5, 4, 5, 5, 5, 4, 5,-1,-1,-1,-1,-1, /* y= 0101  q=11000 */
-1, 4, 5, 5, 5, 4, 5, 5, 5, 4, 5, 5, 5, 5, 5, 4, /* b=01100  r=11001 */
 5, 5, 5, 5, 5, 4, 5, 5, 5, 4, 5,-1,-1,-1,-1,-1, /* c=01101  s=11010 */
-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, /* d=01110  t=11011 */
-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, /* f=01111  v=11100 */
-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, /* g=10000  w=11101 */
-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, /* h=10001  x=11110 */
-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, /* j=10010  z=11111 */
-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
int CodeChar[256] = {
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,000,014,015,016,001,017,020,021,002,022,023,024,025,026,
003,027,030,031,032,033,004,034,035,036,005,037,0,0,0,0,0,
0,000,014,015,016,001,017,020,021,002,022,023,024,025,026,
003,027,030,031,032,033,004,034,035,036,005,037,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

FILE *filep; /* ,*fopen(const char *,const char *);*/
unsigned char *Text,*File2Hide;
int LenText,LenFile2Hide;
int PosText,PosFile2Hide;
int CodeCharHidden,LenCharHidden,CodeChar2Hide,LenChar2Hide;
unsigned char c,Char2Hide;
int i;

int main(argc,argv) int argc; char *argv[]; {
  
  setbuf(stdout, NULL); /* no buffering for output! */
  if((argc<2)||(argc>3)) { printf("usage:\n %s TextFile\n %s TextFile File2Hide\n",argv[0],argv[0]); exit(1); }
  
  /* get length of TextFile, allocate memory and load it */
  filep=fopen(argv[1],"rb");
  if(filep==0) { printf("error: %s not found\n",argv[1]); exit(1); }
  fseek(filep,0,2); LenText=(int) ftell(filep); fseek(filep,0,0);
  Text=(unsigned char *) malloc((unsigned int) LenText);
  fread(Text,1,LenText,filep);
  fclose(filep);
  if(argc==3) {
    /* get length of File2Hide, allocate memory and load it */
    filep=fopen(argv[2],"rb");
    if(filep==0) { printf("error: %s not found\n",argv[2]); exit(1); }
    fseek(filep,0,2); LenFile2Hide=(int) ftell(filep); fseek(filep,0,0);
    File2Hide=(unsigned char *) malloc((unsigned int) LenFile2Hide);
    fread(File2Hide,1,LenFile2Hide,filep);
    fclose(filep);
  }

  PosText=0;
  PosFile2Hide=0;
  CodeChar2Hide=0;
  LenChar2Hide=0;
  CodeCharHidden=0;
  LenCharHidden=0;
  
  do {
    if(argc==3) {
      /* Get a Char2Hide from the File2Hide file, with wrapping */
      while(LenChar2Hide<=0) {
        Char2Hide=File2Hide[PosFile2Hide];
        PosFile2Hide++;
        if(PosFile2Hide==LenFile2Hide) { PosFile2Hide=0; }     
        LenChar2Hide=LenChar[Char2Hide];
        CodeChar2Hide=CodeChar[Char2Hide];
      }
    }
    /* get a char */
    c=Text[PosText];
    PosText++;
    if((c>='A' && c<='Z') ||(c>='a' && c<='z')) {
      /* set bit of CodeCharHidden accordingly to uppercase/lowercase status */
      CodeCharHidden=CodeCharHidden*2;
      if(c<='Z') {
        c=c+'a'-'A';
        CodeCharHidden++;
      }
      LenCharHidden++;
      /* if CodeCharHidden exists and argc==2 print it */
      for(i=256;i>0;i--) {
        if((LenCharHidden==LenChar[i]) && (CodeCharHidden==CodeChar[i]) && (argc==2)) {
          printf("%c",i);
          LenCharHidden=0;
          CodeCharHidden=0;
        }
      }
      /* set uppercase/lowercase status according to bit of CodeChar2Hide */
      LenChar2Hide--;
      if((CodeChar2Hide & (1<<LenChar2Hide))!=0) {
        c=c-'a'+'A';
      }
    }
    if(argc==3) { printf("%c",c); }
    
  } while (PosText<LenText);
  
  exit(0);
}
