/* GfxPacKer by baah/Arm's Tech - 2005aug23 */
#include <stdio.h>  /* file functions, etc... */
#include <stdlib.h> /* exit(), malloc() */

#define BPP 4    /* Bits Per Pixel */
#define BoxN 4   /* nb of bits used to store Boxes widths and heights */
#define BoxMax 15 /* 2^BoxN-1 */
#define ImgW 16
#define ImgH 16
#define TRUE 1
#define FALSE 0

struct Box {
  int x,y,w,h; /* x pos, y pox, width, height */
  unsigned char c; /* color */
};


int main() {
  FILE *FilePtr;
  char *FileName;
  unsigned char *Img;
  short *Img2;
  struct Box BestBox;
  int ImgSize,BoxSizeMin,PixelColor,BestBoxSize;
  char BoxValidity[BoxMax+1],stoph,stopw;
  int c,x,y,w,h; /* counters */
  /**** load file and convert pixels to shorts */
  ImgSize=ImgW*ImgH;
  FileName="test16_1.raw";
  FilePtr=fopen(FileName,"rb");
  if(FilePtr==0) { printf("error: %s not found\n",FileName); exit(1); }
  Img=(char *) calloc((unsigned int) ImgSize,sizeof(unsigned char));
  Img2=(short *) calloc((unsigned int) ImgSize,sizeof(short));
  fread(Img,1,ImgSize,FilePtr);
  fclose(FilePtr);
  for(c=0;c<ImgSize;c++) { Img2[c]=(short) Img[c]; }
  /**** */
  BoxSizeMin=9; /* log2(ImgSize)/BPP + 2*BoxN/BPP + 1 */
  do {
    BestBoxSize=BoxSizeMin;
    BestBox.x=-1; BestBox.y=-1; BestBox.w=0; BestBox.h=0; BestBox.c=0;
    for(y=0;y<ImgH;y++) {
      for(x=0;x<ImgW;x++) {
        for(c=0;c<=BoxMax;c++) { BoxValidity[c]=TRUE; }
        PixelColor=Img2[y*ImgW+x];
        if(PixelColor!=-1) {
          h=0;
          stoph=FALSE;
          do {
            c=Img2[(y+h)*ImgW+x];
            if((c==PixelColor) || (c==-1)) {
              w=0;
              stopw=FALSE;
              do {
                if(BoxValidity[w]==TRUE) {
                  c=Img2[(y+h)*ImgW+x+w];
                  if((c==PixelColor) || (c==-1)) {
                    c=(w+1)*(h+1);
                    if(c>BestBoxSize) {
                      BestBox.x=x;
                      BestBox.y=y;
                      BestBox.w=w;
                      BestBox.h=h;
                      BestBox.c=PixelColor;
                      BestBoxSize=c;
                    } /* endif */
                  } else {
                    BoxValidity[w]=FALSE;
                    stopw=TRUE;
                  } /* endif */
                } else {
                  stopw=TRUE;
                } /* endif */
                w++;
                if(x+w>=ImgW) { stopw=TRUE; }
              } while((w<=BoxMax) && (stopw!=TRUE));
            } else {
              stoph=TRUE;
            }
            h++;
            if(y+h>=ImgH) { stoph=TRUE; }
          } while((h<=BoxMax) && (stoph!=TRUE));
          
        } else { /* pixel has already been processed */
        /*!!!*/
        
        } /* endif */
      } /* next x */
    } /* next y */
    if(BestBoxSize!=BoxSizeMin) {
      x=BestBox.x;
      y=BestBox.y;
      printf("(%d,%d) -> (%d,%d)\n",x,y,x+BestBox.w,y+BestBox.h);
      for(h=0;h<=BestBox.h;h++) {
        for(w=0;w<=BestBox.w;w++) {
          Img2[(y+h)*ImgW+x+w]=-1;
        }
      }
    }
  } while(BestBoxSize!=BoxSizeMin);
  
  exit(0);
}
