/* Mondrian by baah/Arm's Tech - 2005aug26 -> 29 */
/* !!! je compresse les couleurs les unes a la suite des autres. */
/*     Malheureusement cela est moins bon. */
/* !!! En plus j'essaye de maximiser le nb pixels du bord */
/*     Mais si je l'enleve on s'apercoit que c'est pas meilleur! */

#include <stdio.h>  /* file functions, etc... */
#include <stdlib.h> /* exit(), malloc() */

#define BPP 4    /* Bits Per Pixel */
#define ImgW 320
#define ImgH 200
#define ImgS 16    /* log2(ImgW*ImgH) */
#define TRUE 1
#define FALSE 0

struct Box {
  int x,y,w,h; /* x pos, y pox, width, height */
  unsigned char c; /* color */
  struct Box *previous;
};

/* global variable */
unsigned char *Pk;

void PutNibble(position,nibble) int position,nibble; {
  int pos;
  unsigned char nib;
  pos=position>>1;
  nib=(unsigned char) nibble & 15;
  if((position & 1)==0) {
    Pk[pos]=(Pk[pos] & 15) | (nib<<4);
  } else {
    Pk[pos]=(Pk[pos] & 240) | nib;
  }
}

int main() {
  FILE *FilePtr;
  char *FileName,*ImgTmp;
  short *Img;
  struct Box BestBox,*PreviousBox,*NewBox;
  int ImgSize,BoxSizeMin,Size,NbBoxes,BoxColor;
  int BoxS,EdgeS,BestBoxSize,BestEdgeSize;
  int BoxSize[ImgW],EdgeSize[ImgW];
  char stoph,stopw;
  int c,x,y,w,h,maxw,maxh; /* counters */
  
  maxw=0;
  maxh=0;
  PreviousBox=NULL;
  /**** load file and convert pixels to shorts */
  ImgSize=ImgW*ImgH;
  FileName="fanta.raw";
  FilePtr=fopen(FileName,"rb");
  if(FilePtr==0) { printf("error: %s not found\n",FileName); exit(1); }
  Pk=(unsigned char *) calloc((unsigned int) ImgSize,sizeof(unsigned char));
  fread(Pk,1,ImgSize,FilePtr);
  fclose(FilePtr);
  Img=(short *) calloc((unsigned int) ImgSize,sizeof(short));
  for(c=0;c<ImgSize;c++) { Img[c]=(short) Pk[c]; }
  ImgTmp=(char *) calloc((unsigned int) ImgSize,sizeof(char));
      
  /**** Find biggest boxes while it is profitable */
  BoxSizeMin=8; /* log2(ImgSize)/BPP + 2*BoxN/BPP */
  NbBoxes=0;
  for(BoxColor=0;BoxColor<15;BoxColor++) {
    /* convert image so that:
         pixel of color BoxColor, on the edge : 2
         pixel of color BoxColor : 1
         neutral pixels : 0
         pixel of different color : -1    */
    for(y=0;y<ImgH;y++) {
      for(x=0;x<ImgW;x++) {
        c=y*ImgW+x;
        if(Img[c]==BoxColor) {
          ImgTmp[c]=1;
          if((y==0) || (y==ImgH-1)) { ImgTmp[c]=2; }
          if((y>0) && (Img[c-ImgW]!=BoxColor)) { ImgTmp[c]=2; }
          if((y<ImgH-1) && (Img[c+ImgW]!=BoxColor)) { ImgTmp[c]=2; }
          if((x==0) || (x==ImgW-1)) { ImgTmp[c]=2; }
          if((x>0) && (Img[c-1]!=BoxColor)) { ImgTmp[c]=2; }
          if((x<ImgW-1) && (Img[c+1]!=BoxColor)) { ImgTmp[c]=2; }
        } else if(Img[c]==-1) {
          ImgTmp[c]=0;
        } else {
          ImgTmp[c]=-1;
        }
      } /* next x */
    } /* next y */
    
    /* Now we search the Box that has the biggest number of edge pixels */
    do {
      BestBoxSize=0;
      BestEdgeSize=0;
      for(y=0;y<ImgH;y++) {
        for(x=0;x<ImgW;x++) {
          if(ImgTmp[y*ImgW+x]>=0) {
            for(c=0;c<ImgW;c++) { EdgeSize[c]=0; BoxSize[c]=0; }
            h=0;
            stoph=FALSE;
            do {
              if(ImgTmp[(y+h)*ImgW+x]>=0) {
                w=0;
                stopw=FALSE;
                BoxS=0;
                EdgeS=0;
                do {
                  if(BoxSize[w]>=0) {
                    c=ImgTmp[(y+h)*ImgW+x+w];
                    if(c>=0) {
                      if(c>0) { BoxS++; }
                      if(c==2) { EdgeS++; }
                      BoxSize[w]=BoxSize[w]+BoxS;
                      EdgeSize[w]=EdgeSize[w]+EdgeS;
                      /* !!! on pourrait faire qu'un seul if */
                      if(BoxSize[w]>=BoxSizeMin) {
                        if(EdgeSize[w]>BestEdgeSize) {
                          BestBox.x=x; BestBox.y=y;
                          BestBox.w=w; BestBox.h=h;
                          BestBox.c=BoxColor;
                          BestEdgeSize=EdgeSize[w];
                          BestBoxSize=BoxSize[w];
                        } else if((EdgeSize[w]==BestEdgeSize) && (BoxSize[w]>=BestBoxSize)) {
                          BestBox.x=x; BestBox.y=y;
                          BestBox.w=w; BestBox.h=h;
                          BestBox.c=BoxColor;
                          BestEdgeSize=EdgeSize[w];
                          BestBoxSize=BoxSize[w];
                        } /* endif */
                      } /* endif */
                    } else {
                      BoxSize[w]=-1;
                      stopw=TRUE;
                    } /* endif */
                  } else {
                    stopw=TRUE;
                  } /* endif */
                  w++;
                } while((stopw!=TRUE) && (x+w<ImgW));
              } else {
                stoph=TRUE;
              } /* endif */
              h++;
            } while((stoph!=TRUE) && (y+h<ImgH));
          } /* endif */
        } /* next x*/
      } /*next y */
      if(BestBoxSize>=BoxSizeMin) {
        if(BestBox.w>maxw) { maxw=BestBox.w; }
        if(BestBox.h>maxh) { maxh=BestBox.h; }
        NbBoxes++;
        x=BestBox.x;
        y=BestBox.y;
        printf("(%d,%d) -> (%d,%d): %d\n",x,y,x+BestBox.w,y+BestBox.h,BestBox.c);
        for(h=0;h<=BestBox.h;h++) {
          for(w=0;w<=BestBox.w;w++) {
            ImgTmp[(y+h)*ImgW+x+w]=0;
            Img[(y+h)*ImgW+x+w]=-1;
          }
        }
        NewBox=(struct Box *) malloc(sizeof(struct Box));
        NewBox -> x=BestBox.x; NewBox -> y=BestBox.y;
        NewBox -> w=BestBox.w; NewBox -> h=BestBox.h;
        NewBox -> c=BestBox.c; NewBox -> previous=PreviousBox;
        PreviousBox=NewBox;
      }
    } while(BestBoxSize>=BoxSizeMin);
  } /* next BoxColor */
    
  /**** save Boxes in reverse order */
  c=0;
  for(x=0;x<NbBoxes;x++) {
    y=(NewBox -> y)*ImgW+(NewBox -> x);
    PutNibble(c++,y>>12); PutNibble(c++,y>>8);
    PutNibble(c++,y>>4);  PutNibble(c++,y);
    y=((NewBox-> y)+(NewBox -> h))*ImgW+(NewBox -> x)+(NewBox -> w);
    PutNibble(c++,y>>12); PutNibble(c++,y>>8);
    PutNibble(c++,y>>4);  PutNibble(c++,y);
/*    PutNibble(c++,NewBox -> c); */
    NewBox=NewBox -> previous;
  }
  /**** put escape character for end of boxes */
  /*!!! on ST the escape char is $ff, otherwise we can use ImgH*ImgW-1,
    !!! since no box will ever start on this pixel */
  PutNibble(c++,15);
  PutNibble(c++,15);
  /**** Count number of pixels left and copy them */
  Size=0;
  for(y=0;y<ImgH;y++) {
    for(x=0;x<ImgW;x++) {
      if(Img[y*ImgW+x]!=-1) {
        PutNibble(c++,Img[y*ImgW+x]);
        Size++;
      }
    }
  }
  printf("maxw=%d  -  maxh=%d\n",maxw,maxh);
  printf("%d boxes and %d residual pixels: %d bytes\n",NbBoxes,Size,c>>1);
  /**** save resulting file */
  FilePtr=fopen("fanta.pk","wb");
  if(FilePtr==0) { printf("error: cannot save\n"); exit(1); }
  fwrite(Pk,1,(c+1)>>1,FilePtr);
  fclose(FilePtr);
  
  exit(0);
}
