// Alain Brobecker - 2011/01/06

#include <stdio.h>  /* file functions, etc... */
#include <stdlib.h> /* exit(), malloc() */
#include <math.h>

#define NbTriplesMax 1000
#define MaxValue 99

int main() {
  int Triplet[NbTriplesMax][3];
  float Slope[NbTriplesMax];
  int NbTriples=0;
  int m,n,p,m2plusn2;
  int c;
  int NbM[(MaxValue+1)*2],NbN[(MaxValue+1)*2],NbP[(MaxValue+1)*2]; // normally *sqrt(2) and only for NbP, but...
  
  for(c=0;c<MaxValue*2;c++) {
    NbM[c]=0;
    NbN[c]=0;
    NbP[c]=0;
  }
  
  // search Pythagorean triples and save them in Triplet[][3]
  for(m=1;m<MaxValue;m++) {
    for(n=m+1;n<MaxValue+1;n++) {
      m2plusn2=m*m+n*n;
      p=(int) sqrt(m2plusn2);
      if((p*p==m2plusn2)
//           && (p<100)
//           && (m%10!=0) && (n%10!=0) && (p%10!=0) 
        ){
        Triplet[NbTriples][0]=m;
        Triplet[NbTriples][1]=n;
        Triplet[NbTriples][2]=p;
        Slope[NbTriples]=(float) m/(float) n;
        NbTriples++;
        NbM[m]++;
        NbN[n]++;
        NbP[p]++;
//        printf("%d;%d;%d;%f\n",m,n,p,(float) m/(float) n);
      }
    }
  }
  
  //sort Pythagorean triples according to m/n
  
  
  //print Pythagorean triples
  printf("<html>\n");
  printf("<table cellspacing=2>\n");
  printf("<tr><td><b>m</b></td><td><b>n</b></td><td><b>p</b></td><td>;m/n;</td></tr>\n");
  for(c=0;c<NbTriples;c++) {
    m=Triplet[c][0];
    n=Triplet[c][1];
    p=Triplet[c][2];
    
    printf("<tr><td>");
    if((NbM[m]>1) || (NbN[m]>0)) { printf("<i>"); }
    if(NbP[m]>0) { printf("<b>"); }
    printf("%d",m);
    if(NbP[m]>0) { printf("</b>"); }
    if((NbM[m]>1) || (NbN[m]>0)) { printf("</i>"); }
    printf("</td><td>");
    if((NbN[n]>1) || (NbM[n]>0)) { printf("<i>"); }
    if(NbP[n]>0) { printf("<b>"); }
    printf("%d",n);
    if(NbP[n]>0) { printf("</b>"); }
    if((NbN[n]>1) || (NbM[n]>0)) { printf("</i>"); }
    printf("</td><td>");
    if(NbP[p]>1) { printf("<i>"); }
    if((NbM[p]>0) || (NbN[p]>0)) { printf("<b>"); }
    printf("%d",p);
    if((NbM[p]>0) || (NbN[p]>0)) { printf("</b>"); }
    if(NbP[p]>1) { printf("</i>"); }
    printf("</td><td>;%f;</td></tr>\n",(float) m/(float) n);
  }
  printf("</table>)\n");
  printf("</html>\n");
  
  
  return(0);
}
