// 2009/12/06 - Alain Brobecker
// Brute force search of self referencing sentences such as:
// "This sentence contains 2 times the 1 figure, 3 times the 2 figure,
//  2 times the 3 figure and 1 time the 4 figure.".

//* Cette phrase contient ... fois le chiffre 2,
//                        et aucun autre chiffre.
//  Une solution: 2x2
//* Cette phrase contient ... fois le chiffre 0,
//                        ... fois le chiffre 1,
//                        ... fois le chiffre 2,
//                        ... fois le chiffre 3,
//                        et aucun autre chiffre.
//  !!! DEUX solutions: 1x0, 2x1, 3x2, 2x3. (0 peut tre remplac)
//                      1x0, 3x1, 1x2, 3x3. (0 et 2 peuvent tre remplacs)
//* Cette phrase contient ... fois le chiffre 0,
//                        ... fois le chiffre 1,
//                        ... fois le chiffre 2,
//                        ... fois le chiffre 3,
//                        ... fois le chiffre 4,
//                        et aucun autre chiffre.
//  Une solution: 1x0, 3x1, 2x2, 3x3, 1x4. (0 et 4 peuvent tre remplacs)
//* Cette phrase contient ... fois le chiffre 0,
//                        ... fois le chiffre 1,
//                        ... fois le chiffre 2,
//                        ... fois le chiffre 3,
//                        ... fois le chiffre 4,
//                        ... fois le chiffre 5,
//                        ... fois le chiffre 6,
//                        et aucun autre chiffre.
//  Une solution: 1x0, 4x1, 3x2, 2x3, 2x4, 1x5, 1x6. (0, 5 et 6 peuvent tre remplacs)
//* Cette phrase contient ... fois le chiffre 0,
//                        ... fois le chiffre 1,
//                        ... fois le chiffre 2,
//                        ... fois le chiffre 3,
//                        ... fois le chiffre 4,
//                        ... fois le chiffre 5,
//                        ... fois le chiffre 6,
//                        ... fois le chiffre 7,
//                        et aucun autre chiffre.
//  Une solution: 1x0, 5x1, 3x2, 2x3, 1x4, 2x5, 1x6, 1x7. (0, 4, 6 et 7 peuvent tre remplacs)
//* Cette phrase contient ... fois le chiffre 0,
//                        ... fois le chiffre 1,
//                        ... fois le chiffre 2,
//                        ... fois le chiffre 3,
//                        ... fois le chiffre 4,
//                        ... fois le chiffre 5,
//                        ... fois le chiffre 6,
//                        ... fois le chiffre 7,
//                        ... fois le chiffre 8,
//                        et aucun autre chiffre.
//  !!! DEUX solutions: 1x0, 6x1, 3x2, 2x3, 1x4, 1x5, 2x6, 1x7, 1x8. (0, 4, 5, 7 et 8 peuvent tre remplacs)
//                      1x0, 11x1, 1x2, 1x3, 1x4, 1x5, 1x6, 1x7, 1x8. (seul 1 ne peut pas tre remplac)
//* Cette phrase contient ... fois le chiffre 0,
//                        ... fois le chiffre 1,
//                        ... fois le chiffre 2,
//                        ... fois le chiffre 3,
//                        ... fois le chiffre 4,
//                        ... fois le chiffre 5,
//                        ... fois le chiffre 6,
//                        ... fois le chiffre 7,
//                        ... fois le chiffre 8,
//                        ... fois le chiffre 9.
//  !!! DEUX solutions: 1x0, 7x1, 3x2, 2x3, 1x4, 1x5, 1x6, 2x7, 1x8, 1x9.
//                      1x0, 11x1, 2x2, 1x3, 1x4, 1x5, 1x6, 1x7, 1x8, 1x9.

/* Fichier .csv de sortie,  trier par colonne A puis B croissantes
10/12/2009 
15:30
2;x2;;2
8;x1x2x3;x0;2;3;2;1
8;x1x3;x0x2;3;3;1;1
8;x1x2x3;x4;2;3;2;1
8;x1x3;x0x4;3;3;1;1
8;x1x3;x2x4;3;3;1;1
10;x1x2x3;x0x4;3;2;3;1;1
8;x1x2x3;x5;2;3;2;1
8;x1x3;x0x5;3;3;1;1
8;x1x3;x2x5;3;3;1;1
10;x1x2x3;x0x5;3;2;3;1;1
8;x1x3;x4x5;3;3;1;1
10;x1x2x3;x4x5;3;2;3;1;1
8;x1x2x3;x6;2;3;2;1
8;x1x3;x0x6;3;3;1;1
8;x1x3;x2x6;3;3;1;1
10;x1x2x3;x0x6;3;2;3;1;1
8;x1x3;x4x6;3;3;1;1
10;x1x2x3;x4x6;3;2;3;1;1
8;x1x3;x5x6;3;3;1;1
10;x1x2x3;x5x6;3;2;3;1;1
14;x1x2x3x4;x0x5x6;4;3;2;2;1;1;1
8;x1x2x3;x7;2;3;2;1
8;x1x3;x0x7;3;3;1;1
8;x1x3;x2x7;3;3;1;1
10;x1x2x3;x0x7;3;2;3;1;1
8;x1x3;x4x7;3;3;1;1
10;x1x2x3;x4x7;3;2;3;1;1
8;x1x3;x5x7;3;3;1;1
10;x1x2x3;x5x7;3;2;3;1;1
14;x1x2x3x4;x0x5x7;4;3;2;2;1;1;1
8;x1x3;x6x7;3;3;1;1
10;x1x2x3;x6x7;3;2;3;1;1
14;x1x2x3x4;x0x6x7;4;3;2;2;1;1;1
14;x1x2x3x4;x5x6x7;4;3;2;2;1;1;1
16;x1x2x3x5;x0x4x6x7;5;3;2;2;1;1;1;1
8;x1x2x3;x8;2;3;2;1
8;x1x3;x0x8;3;3;1;1
8;x1x3;x2x8;3;3;1;1
10;x1x2x3;x0x8;3;2;3;1;1
8;x1x3;x4x8;3;3;1;1
10;x1x2x3;x4x8;3;2;3;1;1
8;x1x3;x5x8;3;3;1;1
10;x1x2x3;x5x8;3;2;3;1;1
14;x1x2x3x4;x0x5x8;4;3;2;2;1;1;1
8;x1x3;x6x8;3;3;1;1
10;x1x2x3;x6x8;3;2;3;1;1
14;x1x2x3x4;x0x6x8;4;3;2;2;1;1;1
14;x1x2x3x4;x5x6x8;4;3;2;2;1;1;1
16;x1x2x3x5;x0x4x6x8;5;3;2;2;1;1;1;1
8;x1x3;x7x8;3;3;1;1
10;x1x2x3;x7x8;3;2;3;1;1
14;x1x2x3x4;x0x7x8;4;3;2;2;1;1;1
14;x1x2x3x4;x5x7x8;4;3;2;2;1;1;1
16;x1x2x3x5;x0x4x7x8;5;3;2;2;1;1;1;1
14;x1x2x3x4;x6x7x8;4;3;2;2;1;1;1
19;x1;x0x2x3x4x5x6x7x8;11;1;1;1;1;1;1;1;1
16;x1x2x3x5;x0x6x7x8;5;3;2;2;1;1;1;1
16;x1x2x3x5;x4x6x7x8;5;3;2;2;1;1;1;1
18;x1x2x3x6;x0x4x5x7x8;6;3;2;2;1;1;1;1;1
8;x1x2x3;x9;2;3;2;1
8;x1x3;x0x9;3;3;1;1
8;x1x3;x2x9;3;3;1;1
10;x1x2x3;x0x9;3;2;3;1;1
8;x1x3;x4x9;3;3;1;1
10;x1x2x3;x4x9;3;2;3;1;1
8;x1x3;x5x9;3;3;1;1
10;x1x2x3;x5x9;3;2;3;1;1
14;x1x2x3x4;x0x5x9;4;3;2;2;1;1;1
8;x1x3;x6x9;3;3;1;1
10;x1x2x3;x6x9;3;2;3;1;1
14;x1x2x3x4;x0x6x9;4;3;2;2;1;1;1
14;x1x2x3x4;x5x6x9;4;3;2;2;1;1;1
16;x1x2x3x5;x0x4x6x9;5;3;2;2;1;1;1;1
8;x1x3;x7x9;3;3;1;1
10;x1x2x3;x7x9;3;2;3;1;1
14;x1x2x3x4;x0x7x9;4;3;2;2;1;1;1
14;x1x2x3x4;x5x7x9;4;3;2;2;1;1;1
16;x1x2x3x5;x0x4x7x9;5;3;2;2;1;1;1;1
14;x1x2x3x4;x6x7x9;4;3;2;2;1;1;1
19;x1;x0x2x3x4x5x6x7x9;11;1;1;1;1;1;1;1;1
16;x1x2x3x5;x0x6x7x9;5;3;2;2;1;1;1;1
16;x1x2x3x5;x4x6x7x9;5;3;2;2;1;1;1;1
18;x1x2x3x6;x0x4x5x7x9;6;3;2;2;1;1;1;1;1
8;x1x3;x8x9;3;3;1;1
10;x1x2x3;x8x9;3;2;3;1;1
14;x1x2x3x4;x0x8x9;4;3;2;2;1;1;1
14;x1x2x3x4;x5x8x9;4;3;2;2;1;1;1
16;x1x2x3x5;x0x4x8x9;5;3;2;2;1;1;1;1
14;x1x2x3x4;x6x8x9;4;3;2;2;1;1;1
19;x1;x0x2x3x4x5x6x8x9;11;1;1;1;1;1;1;1;1
16;x1x2x3x5;x0x6x8x9;5;3;2;2;1;1;1;1
16;x1x2x3x5;x4x6x8x9;5;3;2;2;1;1;1;1
18;x1x2x3x6;x0x4x5x8x9;6;3;2;2;1;1;1;1;1
14;x1x2x3x4;x7x8x9;4;3;2;2;1;1;1
19;x1;x0x2x3x4x5x7x8x9;11;1;1;1;1;1;1;1;1
16;x1x2x3x5;x0x7x8x9;5;3;2;2;1;1;1;1
16;x1x2x3x5;x4x7x8x9;5;3;2;2;1;1;1;1
19;x1;x0x2x3x4x6x7x8x9;11;1;1;1;1;1;1;1;1
19;x1;x0x2x3x5x6x7x8x9;11;1;1;1;1;1;1;1;1
19;x1;x0x2x4x5x6x7x8x9;11;1;1;1;1;1;1;1;1
19;x1;x0x3x4x5x6x7x8x9;11;1;1;1;1;1;1;1;1
19;x1;x2x3x4x5x6x7x8x9;11;1;1;1;1;1;1;1;1
21;x1x2;x0x3x4x5x6x7x8x9;11;2;1;1;1;1;1;1;1;1
16;x1x2x3x5;x6x7x8x9;5;3;2;2;1;1;1;1
18;x1x2x3x6;x0x4x7x8x9;6;3;2;2;1;1;1;1;1
18;x1x2x3x6;x0x5x7x8x9;6;3;2;2;1;1;1;1;1
18;x1x2x3x6;x4x5x7x8x9;6;3;2;2;1;1;1;1;1
20;x1x2x3x7;x0x4x5x6x8x9;7;3;2;2;1;1;1;1;1;1
10/12/2009 
23:45
*/


#include <stdio.h>
#include <stdlib.h>
#define TRUE 1
#define FALSE 0
#define NbMax 13
#define MaxFigure 8

int main(argc,argv) int argc; char *argv[]; {
  int Nb[10]; // Nb[0] can only be 1 (no 0) or 2: "et 0 times the other figures".
  int RealNb[10];
  int HighestSetFigure,HighestPossibleNb; // HighestPossibleNb<=HighestSetFigure+4.
  int c,t;
  int SelfReference,Terminate,Incremented;
  int Sum;
  
  Nb[0]=1; for(c=1;c<10;c++) { Nb[c]=0; }
  HighestSetFigure=0;
  HighestPossibleNb=HighestSetFigure+4;
  Terminate=FALSE;
  while(Terminate==FALSE) {
    
//    for(c=0;c<=HighestSetFigure;c++) {
//      printf("%d x %d, ",Nb[c],c);
//    }
//    printf(" # %d\n",HighestPossibleNb);
    
    /**** Check if sentence is valid ****/
    for(c=0;c<10;c++) { RealNb[c]=0; }
    for(c=0;c<=HighestSetFigure;c++) {
      if(Nb[c]!=0) {
        RealNb[c]=RealNb[c]+1; // The figure will appear in sentence, so increment.
        if(Nb[c]>=20) { RealNb[2]=RealNb[2]+1; }
        if(Nb[c]>=10) { RealNb[1]=RealNb[1]+1; }
        t=Nb[c]%10;
        RealNb[t]=RealNb[t]+1; // Increment the figures' occurences according to number.
      }
    }
    SelfReference=TRUE;
    Sum=0;
    for(c=0;c<10;c++) {
      if(Nb[c]!=RealNb[c]) { SelfReference=FALSE; }
      Sum+=RealNb[c];
    }
    /**** If valid print it ****/
    if(SelfReference==TRUE) {
      printf("%d;",Sum);
      // interesting figures (ie more than 1 times)
      for(c=0;c<=HighestSetFigure;c++) {
        if((Nb[c]!=0) && (Nb[c]!=1)) {
          printf("x%d",c);
        }
      }
      // uninteresting figures
      printf(";");
      for(c=0;c<=HighestSetFigure;c++) {
        if(Nb[c]==1) {
          printf("x%d",c);
        }
      }
      // occurences of interesting figures
      for(c=0;c<=HighestSetFigure;c++) {
        if((Nb[c]!=0) && (Nb[c]!=1)) {
          printf(";%d",Nb[c]);
        }
      }
      // occurences of uninteresting figures
      for(c=0;c<=HighestSetFigure;c++) {
        if(Nb[c]==1) {
          printf(";%d",Nb[c]);
        }
      }
//      for(c=0;c<=HighestSetFigure;c++) {
//        if(RealNb[c]!=0) {
//          printf("%d x %d, ",RealNb[c],c);
//        }
//      }
      printf("\n");
    }
    
    /**** Next set of numbers ****/
    Incremented=FALSE;
    c=0;
    while(Incremented==FALSE) {
      Nb[c]=Nb[c]+1;
      if(Nb[c]<=HighestPossibleNb)  {
        Incremented=TRUE;
      } else {
        // go to next figure
        Nb[c]=0;
        c++;
        if(c==MaxFigure+1) { Incremented=TRUE; Terminate=TRUE; }
        if(c>HighestSetFigure) {
          HighestSetFigure++;
          HighestPossibleNb=HighestSetFigure+4;
        }
      }
    }
  } // endwhile(Terminate==FALSE)
  exit(1);  
}
