/*wipetags 2006apr29*/

#include <stdio.h>  /* file functions, etc... */
#include <stdlib.h> /* exit(), malloc() */

#define FALSE           0
#define TRUE            1


int main(argc,argv) int argc; char *argv[]; {
  FILE *filep;
  unsigned char *In,c; /* data */
  int InLength,OutLength;
  int InPos;

  if(argc!=3) { printf("usage: wipetags InFile OutFile\n"); exit(1); }

  /**** load InFile ****/
  filep=fopen(argv[1],"rb");
  if(filep==0) { printf("error: %s not found\n",argv[1]); exit(1); }
  fseek(filep,0,2); /* 2 for EOF */
  InLength=(int) ftell(filep);
  fseek(filep,0,0); /* 0 for SOF */
  In=(unsigned char *) malloc((unsigned int) InLength);
  fread(In,1,InLength,filep);
  fclose(filep);

  /**** wipe all tags ****/
  InPos=0;
  OutLength=0;
  while(InPos<InLength) {
    c=In[InPos++];
    if(c=='<') {
      while((InPos<InLength) && (c!='>')) { c=In[InPos++]; }
    } else {
      In[OutLength++]=c;
    }
  }
  
  /**** save resulting file ****/
  filep=fopen(argv[2],"wb");
  fwrite(In,1,OutLength,filep);
  fclose(filep);
  
  exit(0);
}
