/* 29 july 2004 - baah/Arm's Tech */
#include <stdio.h>

/**** external functions ****/
extern int exit(int);
extern int calloc(unsigned int,unsigned int);

/**** global variables ****/
long int i;
FILE *file1p,*file2p,*file3p,*fopen(const char *,const char *);
long int length1,length2;
char *mem,c;


/*******************************************************************************************/
int main(argc,argv) int argc; char *argv[]; {
  if(argc!=4) { printf("usage: concat infile1 infile2 outfile\n"); exit(1); }
  /* get length of file1 */
  file1p=fopen(argv[1],"rb");
  if(file1p==0) { printf("error: %s not found\n",argv[1]); exit(1); }
  fseek(file1p,0,2); /* 2 for EOF */
  length1=ftell(file1p);
  fseek(file1p,0,0); /* 0 for SOF */
  /* get length of file2 */
  file2p=fopen(argv[2],"rb");
  if(file2p==0) { printf("error: %s not found\n",argv[2]); exit(1); }
  fseek(file2p,0,2); /* 2 for EOF */
  length2=ftell(file2p);
  fseek(file2p,0,0); /* 0 for SOF */
  /* concatenate files */
  mem=(char *) calloc((unsigned int) length1+length2,1); /* memory */
  i=0;
  while((c=getc(file1p))!=EOF) { mem[i++]=c; }
  while((c=getc(file2p))!=EOF) { mem[i++]=c; }
  fclose(file1p);
  fclose(file2p);
  /* save resulting file in file1 */
  file3p=fopen(argv[3],"wb");
  for(i=0;i<length1+length2;i++) { putc(mem[i],file3p); }
  fclose(file3p);
/*!!!  printf("%s\n",mem); */
}
