#include <stdio.h>  /* file functions, etc... */
#include <stdlib.h> /* exit(), malloc() */

/* Global variables */
FILE *filep,*fopen(const char *,const char *);
long int length,pos,c;
unsigned char *file;

/***************************************************************************/
int main(argc,argv) int argc; char *argv[]; {
  if(argc!=2) { printf("usage: doit infile\n"); exit(1); }
  /* get length of file */
  filep=fopen(argv[1],"rb");
  if(filep==0) { printf("error: %s not found\n",argv[1]); exit(1); }
  fseek(filep,0,2); /* 2 for EOF */
  length=(int) ftell(filep);
  fseek(filep,0,0); /* 0 for SOF */
  /* allocate memory and load file */
  file=(unsigned char *) malloc((unsigned long int) length);
  fread(file,1,length,filep);
  fclose(filep);
  /* convert file */
  for(c=0;c<length;c++) {
    file[c]=file[c] ^ 255;  /* eor */
  }
  /* save resulting file */
  filep=fopen(argv[1],"wb");
  fwrite(file,1,length,filep);
  fclose(filep);
}
