/***************************************************************************/
/* Recursively lists all possible permutations of nb elts. For every depth */
/* we go through 1..nb, and if the value has not yet been used, we put it  */
/* in the list, and go on depth+1.                                         */
/******************************************************* Alain Brobecker ***/

#include <stdio.h>

/**** C sucks, i much prefer Basic! ;p *************************************/
#define	AND 	&               /*Logical operators for expressions*/
#define OR  	|
#define EOR	^
#define NOT	~
#define FALSE   0
#define TRUE    -1
#define and     &&              /*Logical operators for conditions*/
#define or      ||
#define not     !

#define IF(expr) if(expr){
#define ELSE    } else {
#define ENDIF	}
#define FOR(expr0,expr1,expr2) for(expr0;expr1;expr2){
#define NEXT    }
#define REPEAT  do {
#define UNTIL(expr) } while(!expr);
#define WHILE(expr) while(expr){
#define ENDWHILE }
#define CASE(expression) switch(expression){
#define WHEN    case
#define ENDCASE }

/***************************************************************************/
#define nb      3
char    list[nb],used[nb];

/***************************************************************************/
void permute(char depth) {
char c,d;
  FOR(c=1,c<=nb,c++)
    IF(used[c]==0)
      list[depth]=c;
      used[c]=1;
      IF(depth==nb)
        printf("(");
        FOR(d=1,d<=nb,d++) printf("%d",list[d]); NEXT
        printf(")\n");
      ELSE
	permute(depth+1);
      ENDIF
      used[c]=0;
    ENDIF
  NEXT
}

/***************************************************************************/
int main() {
char c;
  FOR(c=1,c<nb+1,c++) used[c]=0; NEXT
  permute(1);
}
