/* 13-Sep-2004 - Alain Brobecker */
/* We count the nb of permutations with invariant positions */

#include <stdio.h>

#define maxnb 10
int nb,nbinvariants;
char list[maxnb],used[maxnb];

/***************************************************************************/
void permute(char depth) {
char c,d,invariant;
  for(c=1;c<=nb;c++) {
    if(used[c]==0) {
      list[depth]=c;
      used[c]=1;
      if(depth==nb) {
        invariant=0;
/* !!!       printf("(");*/
        for(d=1;d<=nb;d++) {
/* !!!         printf("%d",list[d]);*/
          if(list[d]==d) { invariant=1; }
        }
/* !!!       printf(")");*/
        if(invariant==1) {
          nbinvariants++;
/* !!!         printf(" * ");*/
        }
/* !!!       printf("\n");*/
      } else {
        permute(depth+1);
      }
      used[c]=0;
    }
  }
}

/***************************************************************************/
int main() {
  char c;
  for(nb=1;nb<maxnb+1;nb++) {
    for(c=1;c<nb+1;c++) { used[c]=0; }
    nbinvariants=0;
    permute(1);
    printf("%d: %d invariants\n",nb,nbinvariants);
  }
}
